//
//  GraphPlot.m
//  Bank02
//
//  Created by Pedro Sousa on 7/11/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "GraphPlotBar.h"


@interface GraphPlotBar ()

@property (nonatomic , strong)NSMutableArray *arrValues;
@property (nonatomic , strong)NSMutableArray *arrLabels;

@end

@implementation GraphPlotBar

@synthesize arrValues = _arrValues;
@synthesize arrLabels = _arrLabels;

-(NSMutableArray *)arrValues
{
    if(_arrValues == nil)
        _arrValues = [[NSMutableArray alloc]init];
    
    return _arrValues;
}

-(NSMutableArray *)arrLabels
{
    if(_arrLabels == nil)
        _arrLabels = [[NSMutableArray alloc]init];
    
    return _arrLabels;
}


-(void)setMaxSizeBar:(float)value
{
    maxSizeBar = value;
}
-(void)setSpaceBar:(float)value
{
    spaceBar = value;
}
-(void)setBarSize:(float)value
{
    barSize = value;
}
-(void)setTotal:(float)value
{
    total = value;
}

-(void)setTopSpace:(float)value
{
    topSpace = value;
}

-(void)setFontSize:(float)value
{
    fontSize = value;
}


-(void)addValue:(float)value label:(NSString*)label;
{
    [self.arrValues addObject:[[NSNumber alloc]initWithFloat:value]];
    [self.arrLabels addObject:label];
}

-(void)reload
{    
    int len = [self.arrValues count];
    self.frame = CGRectMake(0, 0, self.frame.size.width, 50 * len);
    self.contentStretch = CGRectMake(0, 0, 0, 0);
    
    
    [self setNeedsDisplay];
}

-(void)clear
{
    self.arrLabels = [[NSMutableArray alloc]init];
    self.arrValues = [[NSMutableArray alloc]init];
}


-(void)drawRect:(CGRect)rect
{
	[self drawInContext:UIGraphicsGetCurrentContext()];
}

-(void)drawInContext:(CGContextRef)context
{
    NSLog(@"draw");
    
    int len = [self.arrValues count];
    
    for(int i = 0 ; i < len;i++)
    {
        float val = [(NSNumber *)[self.arrValues objectAtIndex:i] floatValue]; 
        
        float per = (100 * val) / total;
        
        float posY = topSpace + (i * spaceBar);
        
        NSString *label = [self.arrLabels objectAtIndex:i];
        
        float colorValue = (1.0f / len) * (i + 1.0f);
        
        float bSize = (per * maxSizeBar) / 100;
        
        [self drawBar:context startYPos:posY size:bSize label:label barColor:colorValue];  
    }
}

-(void)drawBar:(CGContextRef)context startYPos:(float)startPosYValue size:(float)sizeValue label:(NSString *)labelValue barColor:(float)colorValue
{
    fontSize = fontSize == 0 ? 8 : fontSize;
    
    CGContextSelectFont (context, "Helvetica",fontSize,kCGEncodingMacRoman);
    CGContextSetCharacterSpacing (context, 2);
    CGContextSetTextDrawingMode (context, kCGTextFillStroke);
     
    
    CGContextSetRGBFillColor (context, 0 , 0 , colorValue , 1);
    CGContextFillRect (context, CGRectMake (0, startPosYValue, sizeValue, barSize ));
    
    CGContextSetAllowsAntialiasing(context, YES);
    CGContextSetTextMatrix(context, CGAffineTransformMake(1.0,0.0, 0.0, -1.0, 0.0, 0.0));
    CGContextShowTextAtPoint (context, 0, startPosYValue  - 10,[labelValue UTF8String] , labelValue.length);    
}

@end
